-- ** Interface ** Pop up dialogs to setup event alarm with /er

local evDay
local evMonth
local eventId

local warned = 0
local validid = {}
local mess = "\n"
local text2 = ""

function table.contains(table, element)
    for _, value in pairs(table) do
      if value == element then
        return true
      end
    end
    return false
end
  

--local error1 = false
--local menuActive = false

--print("hi")
--print(EventReminderDaysBefore1[1] .. " " .. EventReminderDaysBefore1[2])
-- /run StaticPopup_Show("test")
StaticPopupDialogs.MenuSequence = {
    text = "Which month does the event take place?",
    button1 = "Actual month",
    button2 = "Next Month",
    OnAccept = function()
        evMonth = 0
        StaticPopup_Hide("MenuSequence")
        StaticPopup_Show("Day")
    end,
    OnCancel = function()
        evMonth = 1
        self:Hide();
        StaticPopup_Hide("MenuSequence")
        StaticPopup_Show("Day")
    end,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
    preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
}
     
-- /run StaticPopup_Show("MenuSequence")
StaticPopupDialogs.Day = {
    text = "Event Day",
    button1 = "Next",
    button2 = "Cancel",
    OnAccept = function(self)
        evDay = self.editBox:GetText()
        if (tonumber(evDay) ~= nil) and (((tonumber(evDay) >= C_DateAndTime.GetCurrentCalendarTime().monthDay) or (evMonth == 1)) and (tonumber(evDay) <= 31 and tonumber(evDay) >= 1)) then
            PrintEvents(evDay, evMonth)
            if mess == "" then
                message(text2)
            else
                StaticPopup_Hide("Day")
                StaticPopup_Show("Id", text2, mess)
            end  
        else
            --error1 = true
            message("ERROR: Please, select a valid day.")
            --MenuHandler()
        end
    end,
    hasEditBox = 1,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
    preferredIndex = 3,
}

StaticPopupDialogs.Id = {
    text = "%s%s",
    button1 = "Next",
    button2 = "Cancel",
    OnAccept = function(self)
        eventId = tonumber(self.editBox:GetText())

        if table.contains(validid, eventId) then 
            StaticPopup_Hide("Id")
            StaticPopup_Show("DaysBefore")
        else
            message("ERROR: Please, insert an id that appears on the search results.")
        end
    end,
    hasEditBox = 1,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
    preferredIndex = 3,
}
     
StaticPopupDialogs.DaysBefore = {
    text = "How many days before the event would you like to be reminded?",
    button1 = "Save",
    button2 = "Cancel",
    OnAccept = function(self)
        daysBefore = self.editBox:GetText()
        daysBefore = tonumber(daysBefore)
        validDaysBefore = (C_Calendar.GetDayEvent(evMonth, evDay, eventId).startTime.monthDay - C_DateAndTime.GetCurrentCalendarTime().monthDay)

        if (tonumber(daysBefore) ~= nil) and (validDaysBefore >= daysBefore and daysBefore >= 0) or  (C_Calendar.GetDayEvent(evMonth, evDay, eventId).startTime.month ~= C_DateAndTime.GetCurrentCalendarTime().month and ((C_DateAndTime.GetCurrentCalendarTime().monthDay + daysBefore) <= (31 + C_Calendar.GetDayEvent(evMonth, evDay, eventId).startTime.monthDay))) then 

            EventReminderDaysBefore1 = daysBefore
            EventReminderSavedEvent1 = C_Calendar.GetDayEvent(evMonth, evDay, eventId)
            warned = 1
            message("|c0003fc07You will be reminded " ..  EventReminderDaysBefore1 .. " day/s before this event:\n "  .. 
            EventReminderSavedEvent1.title)
        else
            message("ERROR: Invalid amount of days.")
        end
    end,
    hasEditBox = 1,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
    preferredIndex = 3,
}

-- **Function** Show events in chat that starts on a certain day
function PrintEvents(evDay, evMonth) -- (day, month) 0 for this month, 1 for next...
    local numDayEvents = C_Calendar.GetNumDayEvents(evMonth, evDay)
    local show = false
    --print("--Results--\n")
    for i = 1,numDayEvents,1 do
        event = C_Calendar.GetDayEvent(evMonth, evDay, i)
        -- for guild events sequenceType = ''
        if event.sequenceType == "START" or event.sequenceType == '' --[[and event.eventType == 4--]] then
            --print("id " .. i .. ": " .. event.title)
            mess = mess .. "*" .. i .. "*" .. ": " .. event.title .."\n"
            show = true
            table.insert(validid , i)
        end
    end

    if show == false then
        --print("Maybe the event is too far away.")
        text2 = "**NO RESULTS**: Maybe the event is too far away or there aren't events that begin on this date.\n\n"
        mess = ""
    end
end

-- **Function** that alerts with a message the upcoming of an event x daysbefore
local function upcomingEventMessage (event, daysbefore)
    C_Calendar.OpenCalendar()

    local monthDays = 0
    local monthDay = C_DateAndTime.GetCurrentCalendarTime().monthDay

    local m = C_DateAndTime.GetCurrentCalendarTime().month  --actual month
    local a = event.startTime.month - m -- if its 0, the event starts this month, if its 1, next month...

    -- month difference adjust (1 - 12, we want a 1)
    if (a < 0) then
        a = -a
    end

    -- it avoids having a day 32 for example, but a day 1 instead
    if (event.startTime.month - m) ~= 0 then
        if m == 1 or m == 3 or m == 5 or m == 7 or m == 8 or m == 10 or m == 12 then
            monthDays = 31
        elseif m == 2 then
            monthDays = 28 -- TODO: leap years
        else 
            monthDays = 30
        end
    end 

    local numDayEvents = C_Calendar.GetNumDayEvents(a, (monthDay + daysbefore) - monthDays) 

    -- Search for an event that starts tomorrow and eventType is event_type (other)
    local i = 1
    local continue = true
    
    while (i - 1) < numDayEvents and continue do
        eventx = C_Calendar.GetDayEvent(a, (monthDay + daysbefore) - monthDays, i) 
        if eventx.title == event.title and eventx.startTime.monthDay == event.startTime.monthDay then 
            message("|c0003fc07You have a reminder set for this event that starts in " .. daysbefore .." day/s!!\n" .. event.title)
            warned = 0
            continue = false
        end
        i = i + 1
    end
end

-- ** /er SLASH COMMAND ** open pop up dialog to setup event alarm
SLASH_MENU1 = "/er"

function MenuHandler() 
    validid = {}
    mess = "Please, select the number of the event you would like to be reminded:\n\n"
    text2 = ""
    --menuActive = true
    C_Calendar.OpenCalendar()
    StaticPopup_Show("MenuSequence")
end

function wait()
    if warned == 1 then
        C_Timer.After(30, function() upcomingEventMessage(EventReminderSavedEvent1, EventReminderDaysBefore1) end)
    end
end

-- SLASH COMMANDS ADDED
SlashCmdList["MENU"] = MenuHandler

-- ** Monitor Events **
local f = CreateFrame("Frame")

-- +1 for each day on the calendar, we have to make sure that when we load the function
-- the day we want to access its events its loaded, so 40 should work for all cases (calendar has 42 squares, but sometimes number var doesn't reach that?)
local number = 0 

-- to avoid showing message when reloading ui and opening calendar 40 times
local firstlogin = false       

-- Register to monitor events
f:RegisterEvent("CALENDAR_UPDATE_EVENT_LIST")
f:RegisterEvent("PLAYER_ALIVE")
f:RegisterEvent("ADDON_LOADED")

-- Handle the events as they happen
f:SetScript("OnEvent", function(self, event, arg1)
    if (event == "CALENDAR_UPDATE_EVENT_LIST") and firstlogin then
        number = number + 1
        --print(number)
        -- to avoid crashing on start because function would load 40+ times
        if number == 40 then 
            upcomingEventMessage(EventReminderSavedEvent1, EventReminderDaysBefore1)
            C_Timer.After(5, function() wait() end)
        end 

    elseif (event == "PLAYER_ALIVE") then
        firstlogin = true
        warned = 1
    elseif event == "ADDON_LOADED" and arg1 == "EventReminder" then
        -- Our saved variables, if they exist, have been loaded at this point.
        if EventReminderSavedEvent1 == nil then
        -- This is the first time this addon is loaded; set SVs to default values
            EventReminderSavedEvent1 = 0
        end
        if EventReminderDaysBefore1 == nil then
            EventReminderDaysBefore1 = 40
        end
    end    
end)











